// Standardausgabe verwenden
#include <iostream>
using namespace std;

// Klasse fr Obst
class CFruit
{
  public:

    // Konstruktor: Standardfarbe schwarz
    CFruit()
    { m_r = m_g = m_b = 0.0f; }

     // Destruktor vituell, d.h. alles klar zum Ableiten
    virtual ~CFruit()
    { }

    // Methode verndert keine Werte, darum const
    void printColor() const
    { cout << m_r << " " << m_g << " " << m_b << endl; }

    // virtuell, kann - muss aber nicht berladen werden
    virtual void printType() const
    { cout << "This is a Fruit" << endl; }

    // = 0: rein virtuell - muss berladen werden
    virtual void printName() const = 0;

  protected: // folgende Elemente sind geschtzt

    float m_r, m_g, m_b; // Farbwerte
};


// Klasse fr Bananen
class CBanana : public CFruit
{
  public:

    CBanana()
    { m_r = 1.0f; m_g = 1.0f; m_b = 0.0f; }

    virtual ~CBanana()
    { }

    // Methode wird anstelle derjenigen
    // in CFruit aufgerufen
    virtual void printType() const
    { cout << "This is a very special Fruit" << endl; }

    // Methode implementiert printName() aus CFruit
    virtual void printName() const
    { cout << "banana" << endl; }
};


// Klasse fr pfel
class CApple : public CFruit
{
  public:

    CApple()
    { m_r = 0.0f; m_g = 1.0f; m_b = 0.0f; m_worm = true; }

    virtual ~CApple()
    { }

    // Methode implementiert printName() aus CFruit
    virtual void printName() const
    {
        if (m_worm)
            cout << "apple with worm" << endl;
        else
            cout << "apple" << endl;
    }

  protected:

    bool m_worm; // ist Apfel von Wurm befallen?
};


void printAll(const CFruit& fruit)
{
    fruit.printType();
    fruit.printName();
    fruit.printColor();
}


int main()
{
    // Einen Apfel und eine Banane erzeugen
    CApple  apple;
    CBanana banana;

    printAll(apple);
    printAll(banana);

    return 0;

} // main()
